; routine to get the fieldname when fieldid given
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include flp1_engine_aid_mac
        include flp1_engine_struct_h
        include ram1_inc_keys_err
        include ram1_inc_keys_ext_thg
*
; get fieldname when fieldid given
; fieldname is max 16 chars long and that amount of space has to be available in the return string !!
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.fld   equ     $8      ; id of field (call uword, opt, nnul)
p.ret   equ     $10     ; return fieldname (string or substring (C-string))
; errors
; itnf  buffer id invalid
; ipar  fieldid doesn't exist
cod_FLDN xsub
        regsave d1/a1/a4/a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   codend          ; if not -> error

        move.w  p.fld+2(a5),d1  ; field id
        bpl.s   notdef          ; no, we don't need the default
        moveq   #0,d1
        move.b  b_dfield(a4),d1 ; default field
notdef
        move.l  b_file(a4),a4   ; we only need fileid

        ; now find out the field type
        moveq   #err.ipar,d0    ; assume fieldid doesn't exist
        mulu    #18,d1          ; start of field
        add.w   #f_fields,d1    ; offset in filedata
        lea     0(a4,d1.w),a4   ; start of field
        tst.w   (a4)            ; does this field exist ?
        beq.s   codend          ; no it doesn't

        ; now return the fieldname
        move.w  p.ret-4(a5),d1  ; type of ret param
        moveq   #0,d0
        move.b  (a4)+,d0        ; we don't need the field type
        move.b  (a4)+,d0        ; fieldname length
        move.l  p.ret(a5),a1    ; place to fill in return value
        btst    #thp..sst,d1    ; sub-string ??
        bne.s   sstr
        move.w  d0,(a1)+        ; fill in fieldnamelen
sstr    subq.w  #1,d0           ; adjust to dbf
lp      move.b  (a4)+,(a1)+     ; copy 'another' char
        dbf     d0,lp
        btst    #thp..sst,d1    ; sub-string ??
        beq.s   done
        clr.b   (a1)+           ; end of string marker
done    moveq   #0,d0           ; no error
codend
        subend
;
        end
