; index load
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include win1_dd_src_engine_aid_mac
        include win1_dd_src_engine_struct_h
        include win1_inc_keys_err
        include win1_inc_qdos_sms
        include win1_inc_qdos_ioa
        include win1_inc_keys_sys
        include win1_inc_keys_ext_thg
*
; index load, these files get the extension _ddi (doesn't have to be specified)
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.name  equ     $c      ; name of file (opt, string or substring)
p.dev   equ     $14     ; device of file (opt, string or substring)
p.ret   equ     $1c     ; return index id
; errors
; itnf  bufferid not found
; imem  not enough memory
; fdnf  file or device not found
; isyn  this is not a DATAdesign index file
; .. any other file-error
cod_ILOA xsub
        regsave d1-d7/a0-a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne     codend          ; if not -> error
        move.l  b_file(a4),a3   ; we need the fileid

        ; first allocate the new index
        move.l  #i.len,d1       ; amount of mem needed
        xjsr    getmem          ; alocate it
        bne     codend          ; oops, out of memory
        move.l  p.ret(a5),a1
        move.l  a0,(a1)         ; specify return value
        linkin  b_index(a4),a0  ; link in this index
        move.l  a0,b_dindex(a4) ; and make it new default
        move.l  #'DATA',4(a0)   ; fill in flag
        move.l  #'desi',8(a0)
        move.l  #'gn i',12(a0)
        move.l  #'ndex',16(a0)
        move.l  a4,i_buffer(a0) ; bufferid for this index
        move.l  a0,a2           ; indexid in a2

        ; now we copy the filename
        lea     i_name(a2),a3   ; place to fill in file-name
        moveq   #0,d0           ; clear error for return
        move.w  p.name-4(a5),d1 ; type of parameter
        beq.s   enam            ; not specified -> don't copy
        btst    #thp..str,d1    ; string parameter ?
        beq.s   codnstr         ; no -> ..
        move.l  p.name(a5),a1   ; ptr to name
        move.w  (a1)+,d1        ; string length
        beq.s   enam            ; if zero -> no string to copy
        bra.s   codcps          ; copy string
codnstr btst    #thp..sst,d1    ; sub-string parameter ?
        beq.s   enam
        move.w  p.name-2(a5),d1 ; string length
        beq.s   enam            ; if zero -> no string to copy
        move.l  p.name(a5),a1   ; ptr to name
codcps
        cmp.w   #32,d1          ; check that name is not too long
        bmi.s   codlok          ; not too long
        move.w  #32,d1          ; name max 32 chars
codlok  move.w  d1,(a3)+        ; fill in length
        subq.w  #1,d1           ; prepare for dbf
codcpy  move.b  (a1)+,(a3)+     ; copy a char
        dbf     d1,codcpy       ; and the next one ?...
enam
        ; now we copy the devicename
        lea     i_device(a2),a3 ; place to fill in file-name
        moveq   #0,d0           ; clear error for return
        move.w  p.dev-4(a5),d1  ; type of parameter
        beq.s   edev            ; not specified -> don't copy
        btst    #thp..str,d1    ; string parameter ?
        beq.s   ccdnstr         ; no -> ..
        move.l  p.dev(a5),a1    ; ptr to name
        move.w  (a1)+,d1        ; string length
        beq.s   edev            ; if zero -> no string to copy
        bra.s   ccdcps          ; copy string
ccdnstr btst    #thp..sst,d1    ; sub-string parameter ?
        beq.s   edev
        move.w  p.dev-2(a5),d1  ; string length
        beq.s   edev            ; if zero -> no string to copy
        move.l  p.dev(a5),a1    ; ptr to name
ccdcps
        cmp.w   #32,d1          ; check that name is not too long
        bmi.s   ccdlok          ; not too long
        move.w  #32,d1          ; name max 32 chars
ccdlok  move.w  d1,(a3)+        ; fill in length
        subq.w  #1,d1           ; prepare for dbf
ccdcpy  move.b  (a1)+,(a3)+     ; copy a char
        dbf     d1,ccdcpy       ; and the next one ?...
edev

        mutex                   ; enter supervisor mode, prevent stack from moving about
        suba.w  #70,sp          ; reserve area for filename
openlp
        xjsr    ginam
        moveq   #myself,d1
        moveq   #ioa.kshr,d3    ; new file
        moveq   #ioa.open,d0
        trap    #do.ioa         ; open the file
        cmpi.l  #err.fdnf,d0    ; let's see if we can add DATAD$
        bne.s   opened
        ; ok, can we fill in DATAD$ as device ??
        tst.w   i_device(a2)    ; is there already a device
        bne.s   opened          ; well, forget it
        ; so get the data device, and fill it in
        moveq   #sms.info,d0    ; get system information
        trap    #do.sms2
        move.l  sys_datd(a0),a1 ; DATA_USE device in a1
        lea     i_device(a2),a0
        moveq   #err.fdnf,d0    ; restore error just in case
        move.w  (a1)+,d1        ; length
        move.w  d1,(a0)+
        beq     release
        subq.w  #1,d1           ; prepare for dbf
gfdat   move.b  (a1)+,(a0)+     ; copy a char
        dbf     d1,gfdat        ; and the next one ?...
        ; try opening again
        bra     openlp
opened  tst.l   d0              ; was there an error ??
        bmi     release          ; you must be kidding
        ; when we get here, the file is opened and the chid is in d0

        ; test the file heading
        move.l  sp,a1           ; start of buffer
        moveq   #18,d2          ; nr of bytes to fetch
        xjsr    iob_fmul
        bmi     close           ; please no...
        moveq   #err.isyn,d0    ; assume no DATAdesign file
        move.l  sp,a1
        cmp.l   #'DATA',(a1)+
        bne     close
        cmp.l   #'desi',(a1)+
        bne     close
        cmp.l   #'gn i',(a1)+
        bne     close
        cmp.l   #'ndex',(a1)+
        bne     close
        cmp.w   #'00',(a1)+
        bne     close

        ; well, at least the filename was completely valid
        ; so get  back to user mode
        adda.w  #70,sp
        endmutex

        ; get i_len
        lea     i_len(a2),a1
        moveq   #2,d2           ; 2 bytes
        xjsr    iou_fmul        ; get them
        move.l  d0,d7
        bne     rel

        ; load the sort & filter data
        lea     i_sort(a2),a1   ; start of buffer
        move.l  #200,d2         ; 10x6 + 10x14 bytes
        xjsr    iou_fmul        ; get it
        move.l  d0,d7           ; problem ??
        bne     rel             ; -> ..

loading ; we need an empty index linkage
        move.l  i_free(a2),d1   ; is there one ?
        bne.s   gotfree         ; yes -> ...
        xjsr    getifree        ; get free index linkages
        bne     codend
gotfree ; now use one of these links

        ; fill in the index linkage
        move.l  i_free(a2),a1
        lea     il_id(a1),a1    ; place to put
        moveq   #0,d2
        move.w  i_len(a2),d2
        add.w   d2,d2
        addq.l  #4,d2           ; and recordid
        xjsr    iou_fmul        ; fetch the bytes
        moveq   #0,d7
        cmpi.l  #err.eof,d0     ; end of file ??
        beq.s   done            ; -> done
        move.l  d0,d7
        bne.s   done

        ; now we have to link it
        ; linkind is recursive routine to link a record in the index
linkregs reg    d6/a0/a2/a5
        movem.l linkregs,-(sp)
        move.w  i_len(a2),d3    ; length of compare block
        subq.w  #1,d3
        moveq   #0,d6           ; equals should already be marked
        move.l  i_free(a2),a1
        move.l  il_next(a1),i_free(a2)  ; unlink the item
        lea     i_top(a2),a0
        move.l  a0,-(sp)        ; head pointer of tree
        move.l  a1,a2           ; linkage has to be in a2
        moveq   #0,d2           ; start with false
        xjsr    linkind
        adda.w  #4,sp           ; clean up stack
        move.l  a2,a1           ; keep linkage for possible re-link
        movem.l (sp)+,linkregs

        ; and we have an extra record in the index
        addq.l  #1,i_count(a2)
        tst.l   d0
        beq.s   runnxt

        ; we were unable to link it in
        linkin  i_free(a2),a1   ; re-link index linkage
        ; and we DON'T have an extra record in the index
        subq.l  #1,i_count(a2)

runnxt  bra     loading         ; load next one

; in case of problems, release the file we started, and close
close   move.l  d0,d7           ; preserve error
        moveq   #ioa.clos,d0    ; close the lot
        trap    #do.ioa
        move.l  d7,d0
release
        move.l  d0,d7           ; preserve error
        adda.w  #70,sp          ; release ssp
        endmutex                ; back to user mode
rel     lea     b_index(a4),a1  ; remove index
        xjsr    unlink
        move.l  a2,a0
        xjsr    relmem
        move.l  d7,d0
        bra.s   codend

done    moveq   #ioa.clos,d0    ; close the file
        trap    #do.ioa
        move.l  d7,d0           ; and keep the error
codend  subend
;
        end
