; remove array elements
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include flp1_engine_aid_mac
        include flp1_engine_struct_h
        include ram1_inc_keys_err
        include ram1_inc_keys_k
        include ram1_inc_keys_ext_thg
*
; remove array elements
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.fld   equ     $8      ; id of field (call uword, opt, nnul)
p.place equ     $c      ; first element to remove
p.nr    equ     $10     ; nr of elements to insert
; errors
; itnf  buffer id invalid
; ipar  fieldid doesn't exist
; orng  place has to be >=1
;       nr has to be >=1
; imem  insufficient memory
; rdo   read only buffer
cod_RMVE xsub
        regsave d1-d3/d6/d7/a0-a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   codend          ; if not -> error

        ; we need a read/write buffer
        moveq   #err.rdo,d0
        tst.b   b_view(a4)
        bne.s   codend

        move.w  p.fld+2(a5),d2  ; field id
        bpl.s   notdef          ; no, we don't need the default
        move.b  b_dfield(a4),d2 ; default field
notdef  andi.w  #255,d2
        move.l  b_file(a4),a3   ; we need fileid

        ; now find out the field type
        moveq   #err.ipar,d0    ; assume fieldid doesn't exist
        move.l  d2,d1
        mulu    #18,d1          ; start of field
        add.w   #f_fields,d1    ; offset in filedata
        lea     0(a3,d1.w),a3   ; start of field
        tst.w   (a3)            ; does this field exist ?
        beq.s   codend          ; no it doesn't

        ; check line to fill it in
        moveq   #err.orng,d0    ; assume not
        move.l  p.place(a5),d7  ; place to insert
        ble.s   codend
        subq.l  #1,d7           ; we will need the start of the object
        move.l  p.nr(a5),d6     ; nr of elements to insert
        ble.s   codend

        ; expand d6/d7 to actual nr of bytes
        cmpi.b  #ft.char,(a3)   ; byte oriented
        ble.s   exp
        add.l   d6,d6           ; make it word oriented
        ble.s   codend
        add.l   d7,d7
        ble.s   codend
        cmpi.b  #ft.short,(a3)  ; word oriented ?
        ble.s   exp
        add.l   d6,d6           ; make it long oriented
        ble.s   codend
        add.l   d7,d7
        ble.s   codend
        cmpi.b  #ft.long,(a3)   ; word oriented ?
        ble.s   exp
        add.l   d6,d6           ; make it double oriented
        ble.s   codend
        add.l   d7,d7
        ble.s   codend
exp
        ; something will have changed
        move.b  #1,b_change(a4)

        ; so try to find this field
        move.l  b_mem(a4),a1    ; start of record
        move.l  b_rlen(a4),d1   ; recordlen
        xjsr    findfld         ; find it
        beq.s   old             ; overwrite old field -> ..

        moveq   #0,d0           ; nothing to delete
codend  subend

old     ; see if we can fit it in the field
        move.l  d6,d1
        add.l   d7,d1
        sub.l   rf_len(a1),d1   ; do we have to erase at the end
        bmi.s   remove          ; no -> actual removing

        move.l  d7,d1           ; start
        sub.l   rf_len(a1),d1   ; minus old = decrease
        xjsr    incrfld
        bra     codend

remove  ; we really have to remove
        lea     rf_fld(a1,d7.l),a2      ; start of area to remove
loop    move.b  (a2,d6.l),(a2)+
        addq.l  #1,d1
        bmi.s   loop

        move.l  d6,d1
        neg.l   d1              ; we need it negative
        xjsr    incrfld
        bra     codend
;
        end
