; routine to fill in a long in a field of longs
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include flp1_engine_aid_mac
        include flp1_engine_struct_h
        include ram1_inc_keys_err
*
; fill in a long in a field of longs
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.fld   equ     $8      ; id of field (call uword, opt, nnul)
p.par   equ     $c      ; long to fill in
p.place equ     $10     ; array element to put is
; errors
; itnf  buffer id invalid
; ipar  fieldid doesn't exist
;       field has wrong type
; orng  place has to be >=1
; imem  insufficient memory
; rdo   read only buffer
cod_SLNG xsub
        regsave d1/d2/d7/a0/a1/a3-a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne     codend          ; if not -> error

        ; we need a read/write buffer
        moveq   #err.rdo,d0
        tst.b   b_view(a4)
        bne     codend

        move.w  p.fld+2(a5),d2  ; field id
        bpl.s   notdef          ; no, we don't need the default
        move.b  b_dfield(a4),d2 ; default field
notdef  andi.w  #255,d2
        move.l  b_file(a4),a3   ; we need fileid

        ; now find out the field type
        moveq   #err.ipar,d0    ; assume fieldid doesn't exist
        move.w  d2,d1
        mulu    #18,d1          ; start of field
        add.w   #f_fields,d1    ; offset in filedata
        lea     0(a3,d1.w),a3   ; start of field
        tst.w   (a3)            ; does this field exist ?
        beq.s   codend          ; no it doesn't

        ; fieldtype ok ?
        cmpi.b  #ft.long,(a3)
        bne.s   codend

        ; check place to fill it in
        moveq   #err.orng,d0    ; assume not
        move.l  p.place(a5),d7  ; place to fill in
        ble.s   codend
        add.l   d7,d7           ; short is 2 bytes long
        bmi.s   codend          ; has to stay positive
        add.l   d7,d7           ; long is 4 bytes long
        bmi.s   codend          ; has to stay positive

        ; something will have changed
        move.b  #1,b_change(a4)

        ; so try to find this field
        move.l  b_mem(a4),a1    ; start of record
        move.l  b_rlen(a4),d1   ; recordlen
        xjsr    findfld         ; find it
        beq.s   old             ; overwrite old field -> ..

        ; ok, we have to create a new field for this one
        ; create the field
        move.l  d7,d1           ; field length
        xjsr    newfld          ; create it
        bne.s   codend          ; oops ...

        ; now clear the field
        move.l  p.place(a5),d1  ; loop counter
        lea     rf_fld(a1),a0   ; start of actual field
        subq.l  #2,d1           ; we don't have to clear all of them
        bmi.s   fillit
loop    clr.l   (a0)+           ; clear a long
        subq.l  #1,d1           ; another one ?
        bpl     loop
        bra.s   fillit

old     ; now overwrite the old field
        move.l  d7,d1           ; field length
        sub.l   rf_len(a1),d1   ; minus old length gives increment
        ble.s   fillit          ; only increasing fieldlen please
        xjsr    incrfld         ; increase field length
        bne.s   codend          ; oops ...
        ; now clear the area we added
        move.l  rf_len(a1),d2
        lea     rf_fld(a1,d2.l),a0      ; end of field
loop2   clr.b   -(a0)           ; clear another byte
        subq.l  #1,d1           ; another one ??
        bgt     loop2

fillit
        lea     rf_fld-4(a1,d7.l),a1 ; place where we have to fill in the new value
        move.l  p.par(a5),(a1)  ; fill in new value
codend
        subend
;
        end
