; set sort parameters
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include win1_dd_src_engine_aid_mac
        include win1_dd_src_engine_struct_h
        include win1_inc_keys_err
        include win1_inc_keys_k
*
; set sort parameters
; can handle up to 10 sort levels
; if compare = -1 (optional), than only sorted until previous level
; text/char fields are special
; if 'as text' is set in compare, then uses 8 chars with place as offset in character array
; if 'line' set then place is start of given line (only valid if 'as text' set)
; if not specified 'as text' then compares with chr$ code, else translates with comparearray
; if an element is not privided, then it will be put at the end
; except for part of 'as text', then it will be put at the start
; uses the buffer to store the records during sorting !!
; can mark equal records, these records will get mark value 255. for this c..mark has to be set in level 1
; if indexid passed as parameter -> sort data overwritten, else new index
; the new index will be set as default index for this buffer
; the indextree in not being built by this routine, needs call to IUPD
; parameters
p.id    equ     $4      ; buffer id or indexid (long word, optional)
p.c1    equ     $8      ; compare level 1 (optional, nnul)
p.f1    equ     $c      ; fieldid
p.p1    equ     $10     ; place in field
p.c2    equ     $14     ; compare level 2 (optional, nnul)
p.f2    equ     $18     ; fieldid
p.p2    equ     $1c     ; place in field
p.c3    equ     $20     ; compare level 3 (optional, nnul)
p.f3    equ     $24     ; fieldid
p.p3    equ     $28     ; place in field
p.c4    equ     $2c     ; compare level 4 (optional, nnul)
p.f4    equ     $30     ; fieldid
p.p4    equ     $34     ; place in field
p.c5    equ     $38     ; compare level 5 (optional, nnul)
p.f5    equ     $3c     ; fieldid
p.p5    equ     $40     ; place in field
p.c6    equ     $44     ; compare level 6 (optional, nnul)
p.f6    equ     $48     ; fieldid
p.p6    equ     $4c     ; place in field
p.c7    equ     $50     ; compare level 7 (optional, nnul)
p.f7    equ     $54     ; fieldid
p.p7    equ     $58     ; place in field
p.c8    equ     $5c     ; compare level 8 (optional, nnul)
p.f8    equ     $60     ; fieldid
p.p8    equ     $64     ; place in field
p.c9    equ     $68     ; compare level 9 (optional, nnul)
p.f9    equ     $6c     ; fieldid
p.p9    equ     $70     ; place in field
p.c0    equ     $74     ; compare level 10 (optional, nnul)
p.f0    equ     $78     ; fieldid
p.p0    equ     $7c     ; place in field
p.ret   equ     $84     ; ret long indexid
; errors
; itnf  invalid buffer or indexid
; imem  out of memory
cod_SORT xsub
        regsave d1-d7/a0-a2/a4/a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        beq.s   start           ; ok -> new index
        move.l  a4,d0
        xjsr    testiid         ; is it an indexid ?
        bne.s   codend          ; no -> forget it
        move.l  a4,a2           ; indexid in a2
        bra.s   setparms

start   ; first allocate the new index
        move.l  #i.len,d1       ; amount of mem needed
        xjsr    getmem          ; alocate it
        bne.s   codend          ; oops, out of memory
        linkin  b_index(a4),a0  ; link in this index
        move.l  a0,b_dindex(a4) ; and make it new default
        move.l  #'DATA',4(a0)   ; fill in flag
        move.l  #'desi',8(a0)
        move.l  #'gn i',12(a0)
        move.l  #'ndex',16(a0)
        move.l  a4,i_buffer(a0) ; bufferid for this index
        move.w  #-1,i_filt+i_fcmp(a0)
        move.l  a0,a2           ; indexid in a2
setparms
        move.l  p.ret(a5),a1
        move.l  a2,(a1)         ; specify return value

        ; now fill in the compare data
        lea     i_sort(a2),a1   ; place to fill data in
        lea     p.c1+2(a5),a0   ; place to get it from
        moveq   #29,d1          ; copy 30 words with dbf
cplp    move.w  (a0)+,(a1)+     ; copy a word
        addq.w  #2,a0           ; skip MSword of next param
        dbf     d1,cplp
codend
        subend

; linkind is recursive routine to link a record in the index
; addr of ptr to list: on stack, a2 linkage block (preserved), d2 boolean,
;                      d3 nr of .w to cmp-1, a3 fileid, d6 level 1 compare
; can return err.fex if already exists
; based on zoek routine in "Algoritmen en datastructuren" p284
; can corrupt a0/a1/a5 and d1/d4/d5
        xdef    linkind
p.ptr   equ     $4              ; place, relative to stack where we can find the head ptr of the tree
linkind moveq   #0,d0           ; no problem with linking
        move.l  p.ptr(sp),a0    ; ptr to head ptr
        tst.l   (a0)            ; zero ?
        bne.s   balance         ; no -> figure out a balanced tree
        move.l  a2,(a0)         ; fill in ptr
        clr.l   il_left(a2)
        clr.l   il_right(a2)
        clr.b   il_avl(a2)
        moveq   #1,d2           ; branche has grown
elink   rts                     ; and that's it
balance
        move.l  (a0),a0         ; current linkage
        move.w  d3,d1           ; for loop
        bmi.s   nmrk            ; oops, only compare recordid's (no sort)
        lea     il_index(a0),a0
        lea     il_index(a2),a5
        moveq   #0,d4           ; clear high word for compare without sign
        moveq   #0,d5
cloop   move.w  (a0)+,d4        ; compare a word
        move.w  (a5)+,d5
        cmp.l   d4,d5
        bgt     right           ; link to the right
        blt.s   left            ; link to the left
        dbf     d1,cloop        ; or compare next
                                ; if all equal, order of recordid
        ; see if we have to mark these records
        btst    #c..mark,d6
        beq.s   nmrk

        move.l  p.ptr(sp),a0    ; ptr to head ptr
        move.l  (a0),a0         ; current linkage
        move.l  il_id(a0),d2    ; recordid
        move.l  il_id(a2),d1
        eor.l   d2,d1
        beq.s   nmrk            ; if it is completely equal -> don't mark
        bsr     smrk255
        move.l  il_id(a2),d2    ; recordid
        bsr     smrk255
nmrk    ; consider the order of the recordid's
        move.l  il_id(a2),d1    ; id of new record
        move.l  p.ptr(sp),a0    ; ptr to head ptr
        move.l  (a0),a0         ; current linkage
        cmp.l   il_id(a0),d1    ; compare with top of tree
        bgt     right           ; link to the right
        blt.s   left            ; link to the left
                                ; oops, equal
        moveq   #err.fex,d0     ; so already exists
        rts

left    move.l  p.ptr(sp),a0    ; ptr to head ptr
        move.l  (a0),a0         ; current linkage
        lea     il_left(a0),a0
        move.l  a0,-(sp)        ; head pointer of tree (left branche)
        jsr     linkind         ; !! no register values are preserved !! (recursive call)
        adda.w  #4,sp           ; clean up stack
        move.l  p.ptr(sp),a0    ; and restore pointer
        move.l  (a0),a0         ; to value as at the start
        tst.b   d2              ; has there been any growth ?
        beq     elink           ; no -> in balance
        tst.b   il_avl(a0)      ; how WAS the balance
        beq.s   lcase0          ; when was zero
        bmi.s   lcase_1         ;          -1
lcase1  clr.b   il_avl(a0)      ; balance is perfect
        moveq   #0,d2           ; no growth
        rts
lcase0  move.b  #-1,il_avl(a0)  ; set balance
        rts
lcase_1 move.l  il_left(a0),a1  ; set p1
        tst.b   il_avl(a1)      ; check balance
        bpl.s   l_else          ; <> -1 -> ..
        ; enkelvoudig LL roteren
        move.l  il_right(a1),il_left(a0); p^.links=p1^.rechts
        move.l  a0,il_right(a1) ; p1^rechts=p
        clr.b   il_avl(a0)      ; clear balance
        move.l  p.ptr(sp),a0
        move.l  a1,(a0)         ; p=p1
        clr.b   il_avl(a1)      ; also clear p^bal(=p1^bal)
        moveq   #0,d2           ; no growth
        rts
l_else  ; dubbel LR roteren
        move.l  a2,a5           ; keep a2 for a while
        move.l  il_right(a1),a2 ; p2=p1^rechts
        move.l  il_left(a2),il_right(a1)
        move.l  a1,il_left(a2)
        move.l  il_right(a2),il_left(a0)
        move.l  a0,il_right(a2)
        clr.b   il_avl(a0)      ; get balances figured out
        tst.b   il_avl(a2)
        bpl.s   LR_1
        move.b  #1,il_avl(a0)
LR_1    clr.b   il_avl(a1)
        tst.b   il_avl(a2)
        ble.s   LR_2
        move.b  #-1,il_avl(a1)
LR_2
        move.l  p.ptr(sp),a1    ; get value for p
        move.l  a2,(a1)         ; p=p2
        clr.b   il_avl(a2)      ; in balance p^bal=0 (p aangepast)
        moveq   #0,d2           ; no growth
        move.l  a5,a2           ; restore a2
        rts

right   move.l  p.ptr(sp),a0    ; ptr to head ptr
        move.l  (a0),a0         ; current linkage
        lea     il_right(a0),a0
        move.l  a0,-(sp)        ; head pointer of tree (right branche)
        jsr     linkind         ; !! no register values are preserved !! (recursive call)
        adda.w  #4,sp           ; clean up stack
        move.l  p.ptr(sp),a0    ; and restore pointer
        move.l  (a0),a0         ; to value as at the start
        tst.b   d2              ; has there been any growth ?
        beq     elink           ; no -> in balance
        tst.b   il_avl(a0)      ; how WAS the balance
        bmi     lcase1          ; when was -1 , is same as 1 for other case
        bgt.s   rcase1          ; when was 1
rcase0  move.b  #1,il_avl(a0)   ; set balance
        rts
rcase1  move.l  il_right(a0),a1 ; set p1
        tst.b   il_avl(a1)      ; check balance
        ble.s   r_else          ; <> 1 -> ..
        ; enkelvoudig RR roteren
        move.l  il_left(a1),il_right(a0); p^.rechts=p1^.links
        move.l  a0,il_left(a1)  ; p1^links=p
        clr.b   il_avl(a0)      ; clear balance
        move.l  p.ptr(sp),a0    ; get value for p
        move.l  a1,(a0)         ; p=p1
        clr.b   il_avl(a1)      ; also clear p^bal(=p1^bal)
        moveq   #0,d2           ; no growth
        rts
r_else  ; dubbel RL roteren
        move.l  a2,a5           ; keep a2 for a while
        move.l  il_left(a1),a2  ; p2=p1^links
        move.l  il_right(a2),il_left(a1)
        move.l  a1,il_right(a2)
        move.l  il_left(a2),il_right(a0)
        move.l  a0,il_left(a2)
        clr.b   il_avl(a0)      ; get balances figured out
        tst.b   il_avl(a2)
        ble.s   RL_1
        move.b  #-1,il_avl(a0)
RL_1    clr.b   il_avl(a1)
        tst.b   il_avl(a2)
        bpl.s   RL_2
        move.b  #1,il_avl(a1)
RL_2
        move.l  p.ptr(sp),a1    ; get value for p
        move.l  a2,(a1)         ; p=p2
        clr.b   il_avl(a2)      ; in balance p^bal=0 (p=p2)
        moveq   #0,d2           ; no growth
        move.l  a5,a2           ; restore a2
        rts

;
; routine to fill i_len and all occurences of i_fti
indexlen xsub
        regsave d1/d2/d7/a1/a3
        moveq   #0,d0           ; no error
        lea     f_fields(a3),a3 ; start of fielddata

        ; fill in the field types in the filter data
        lea     i_filt(a2),a1
        moveq   #9,d7           ; loop counter for dbf
flp     cmpi.w  #-1,i_fcmp(a1)  ; end of filter data
        beq.s   fend            ; yep -> ..
        moveq   #0,d1
        move.b  i_ffld(a1),d1   ; fieldid
        mulu    #18,d1          ; offset in list
        move.b  0(a3,d1.w),i_ffti(a1)   ; field type
        adda.w  #i.flen,a1      ; to the next
        dbf     d7,flp
fend
        ; now take care of the sort data (field types and indexlen)
        lea     i_sort(a2),a1   ; start of sort data
        clr.w   i_len(a2)       ; no words to compare just yet
        moveq   #9,d7           ; loop counter for dbf
lenlp   clr.b   i_fti(a1)
        cmpi.w  #-1,i_cmp(a1)   ; end of sort data
        beq.s   lenend          ; yep -> ..
        moveq   #0,d1
        move.b  i_fld(a1),d1    ; fieldid
        mulu    #18,d1          ; offset in list
        move.b  0(a3,d1.w),d1   ; field type
        beq.s   ipar            ; oops invalids fieldid
        cmpi.b  #ft.raw,d1      ; raw fields can't be sorted
        beq.s   ipar
        move.b  d1,i_fti(a1)    ; fill in field type (raw will represent TEXT)
        cmpi.b  #ft.char,d1     ; is this a char field??
        bne.s   len             ; no -> ok
        move.w  i_cmp(a1),d2
        btst    #c..text,d2     ; compare as text ??
        beq.s   len
        move.b  #ft.raw,i_fti(a1)
        addq.w  #4,i_len(a2)
        bra.s   lennxt
len     addq.w  #1,i_len(a2)    ; at least a word long
        cmpi.b  #ft.long,d1     ; a long or more ?
        bmi.s   lennxt          ; no ->
        addq.w  #1,i_len(a2)    ; make it 4 bytes at least
        cmpi.b  #ft.ieee,d1     ; a double ?
        bmi.s   lennxt          ; no ->
        addq.w  #2,i_len(a2)
lennxt  addq.l  #i.slen,a1      ; next parameter
        dbf     d7,lenlp
        bra.s   lenend

ipar    moveq   #err.ipar,d0
lenend  subend

; routine to fill in an index linkage (a1) according to the buffer (a4) and index (a2)
fillil  xsub
        regsave d1-d3/d6/d7/a0-a5
        lea     il_index(a1),a5 ; place to fill in sort data
        lea     i_sort(a2),a0   ; start of sort data
        move.l  b_id(a4),il_id(a1)
        moveq   #9,d7           ; there are 10 sort levels
fill    tst.b   i_fti(a0)       ; is this level present
        beq     fillend         ; no -> finished
        ; first find the field
        move.l  b_rlen(a4),d1   ; recordlen
        move.l  b_mem(a4),a1    ; start of field
        move.b  i_fld(a0),d2    ; fieldid
        xjsr    findfld         ; get it, a1=start of field, d0=error code
        cmpi.b  #ft.char,i_fti(a0)
        bmi     ftext
        beq     fchar
        cmpi.b  #ft.long,i_fti(a0)
        bmi     fshort
        beq.s   flong
fdouble ; fill in a double to sort
        moveq   #-1,d1
        moveq   #-1,d2
        tst.l   d0
        bne.s   fdf
        moveq   #0,d3
        move.w  i_plc(a0),d3
        beq.s   fdf
        add.l   d3,d3
        add.l   d3,d3
        add.l   d3,d3
        cmp.l   rf_len(a1),d3   ; does this item exist ?
        bgt.s   fdf             ; no -> ..
        move.l  rf_fld-8(a1,d3.l),d1
        move.l  rf_fld-4(a1,d3.l),d2
        btst    #31,d1          ; negative number
        bne.s   fdn             ; yes -> ok
        eori.l  #$7fffffff,d1   ; reverse the order for the positive doubles
        eori.l  #$ffffffff,d2
fdn     btst    #c..rvrs,i_cmp+1(a0)
        bne.s   fdf             ; reverse -> all is ok
        eori.l  #$ffffffff,d1
        eori.l  #$ffffffff,d2
fdf     move.l  d1,(a5)+
        move.l  d2,(a5)+
        bra     fillnxt
flong   ; fill in a long to sort
        moveq   #-1,d1
        tst.l   d0
        bne.s   flf
        moveq   #0,d3
        move.w  i_plc(a0),d3
        beq.s   flf
        add.l   d3,d3
        add.l   d3,d3
        cmp.l   rf_len(a1),d3   ; does this item exist ?
        bgt.s   flf             ; no -> ..
        move.l  rf_fld-4(a1,d3.l),d1
        btst    #c..rvrs,i_cmp+1(a0)
        beq.s   flf
        eori.l  #$ffffffff,d1
flf     subi.l  #$80000000,d1
        move.l  d1,(a5)+
        bra     fillnxt
fshort  ; fill in a short to sort
        moveq   #-1,d1
        tst.l   d0
        bne.s   fsf
        moveq   #0,d3
        move.w  i_plc(a0),d3
        beq.s   fsf
        add.l   d3,d3
        cmp.l   rf_len(a1),d3   ; does this item exist ?
        bgt.s   fsf             ; no -> ..
        move.w  rf_fld-2(a1,d3.l),d1
        btst    #c..rvrs,i_cmp+1(a0)
        beq.s   fsf
        eori.w  #$ffff,d1
fsf     subi.w  #$8000,d1
        move.w  d1,(a5)+
        bra     fillnxt
fchar   ; fill in a char to sort
        moveq   #-1,d1
        tst.l   d0
        bne.s   fcf
        moveq   #0,d3
        move.w  i_plc(a0),d3
        beq.s   fcf
        cmp.l   rf_len(a1),d3   ; does this item exist ?
        bgt.s   fsf             ; no -> ..
        moveq   #0,d1
        move.b  rf_fld-1(a1,d3.l),d1
        btst    #c..rvrs,i_cmp+1(a0)
        beq.s   fcf
        eori.b  #$ff,d1
fcf     move.w  d1,(a5)+
        bra     fillnxt
ftext   ; fill in 8-chars to sort
        moveq   #-1,d1
        moveq   #-1,d2
        tst.l   d0
        bne     fdf
        move.l  b_file(a4),a3
        lea     f_order3(a3),a2
        btst    #c..case,i_cmp+1(a0)
        beq.s   ftcase
        suba.w  #512,a2
ftcase  btst    #c..rvrs,i_cmp+1(a0)
        beq.s   ftrvrs
        adda.w  #256,a2
ftrvrs  btst    #c..line,i_cmp+1(a0)
        bne.s   ftline
        moveq   #0,d3
        move.w  i_plc(a0),d3
        beq     fdf
        add.l   d3,d3
        add.l   d3,d3
        add.l   d3,d3
        subq.l  #8,d3           ; there only has to be one letter available
        move.l  rf_len(a1),d0   ; len of field
        sub.l   d3,d0           ; nr of bytes left in field
        ble     fdf             ; no -> ..
        lea     rf_fld(a1,d3.l),a1      ; start of data
ftxt    ; now just copy the data into the buffer
        moveq   #7,d6           ; we need to copy 8 bytes (dbf)
ftclp   subq.l  #1,d0           ; is there another byte in the field
        bmi.s   ftfin           ; no -> add with zero's
        moveq   #0,d1
        move.b  (a1)+,d1        ; get the char
        move.b  0(a2,d1.w),(a5)+; set the equivalent code
        dbf     d6,ftclp        ; another char ??
        bra.s   fillnxt         ; end this sort level

ftfin   move.b  #0,(a5)+        ; another zero
        dbf     d6,ftfin        ; another byte ??
        bra.s   fillnxt         ; end this sort level

ftline  ; we have to start from a new-line
        moveq   #0,d6
        move.w  i_plc(a0),d6
        move.l  rf_len(a1),d0   ; length of field
        lea     rf_fld(a1),a1   ; actual start of field
        subq.l  #1,d6           ; one less nl to search
        beq.s   eflin           ; nothing to search ->
flin    subq.l  #1,d0           ; check another byte
        bmi     fdf             ; end reached -> can't find line
        cmpi.b  #k.nl,(a1)+     ; reached the end of a line ?
        bne.s   flin
        subq.l  #1,d6           ; is this the line we need
        bgt.s   flin            ; no -> search next line
eflin   bra     ftxt

fillnxt addq.l  #i.slen,a0      ; next sort level
        dbf     d7,fill
fillend subend

; routine to set the mark status of given record-id (d1) to 255
smrk255 subr
        regsave d1/a1
        mutex
        xjsr    findrec         ; get the record linkage
        bne.s   smend
        tst.b   f_file(a3)
        bne.s   smfile
        move.l  rl_pos(a1),a1
        move.b  #255,r_mark(a1)
        bra.s   smend
smfile  ; set mark status on file
        move.l  f_chid(a3),a0
        move.l  rl_pos(a1),d1
        xjsr    iof_posa        ; position file
        bne.s   smend
        xjsr    iob_fbyt
        bne.s   smend
        cmpi.b  #'R',d1
        bne.s   smend
        move.w  #255,d1
        xjsr    iob_sbyt
smend   endmutex
        subend

; get another 100 free index linkages
; needs indexid in a2
getifree xsub
        regsave d1/a0
        ; allocate some memory for 100 new index linkages
        moveq   #0,d1
        move.w  i_len(a2),d1    ; len of sort data
        add.w   d1,d1           ; but we need it in bytes
        add.w   #il.len,d1      ; length for one empty leaf
        mulu    #100,d1         ; and we need 110 of them
        addq.l  #4,d1           ; and some space for the area linkage
        xjsr    getmem          ; get the memory
        bne     codend          ; imem -> ..
        linkin  i_area(a2),a0   ; link the area in
        addq.w  #4,a0

        moveq   #99,d1          ; nr of links
lnkloop
        linkin  i_free(a2),a0   ; link in
        move.l  #-1,il_id(a0)   ; mark as unused
        adda.w  #il.len,a0      ; go to next one
        adda.w  i_len(a2),a0
        adda.w  i_len(a2),a0
        dbf     d1,lnkloop      ; and link next one
        subend
;
        end
