; fill in a line in a text field
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include flp1_engine_aid_mac
        include flp1_engine_struct_h
        include ram1_inc_keys_err
        include ram1_inc_keys_k
        include ram1_inc_keys_ext_thg
*
; fill in a line in a text field
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.fld   equ     $8      ; id of field (call uword, opt, nnul)
p.str   equ     $10     ; ptr to string to fill in
p.line  equ     $14     ; line to fill in
; errors
; itnf  buffer id invalid
; ipar  fieldid doesn't exist
;       field has wrong type
; ipar  place has to be >=1
; imem  insufficient memory
; rdo   read only buffer
cod_SSTR xsub
        regsave d1-d3/d6/d7/a0-a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne     codend          ; if not -> error

        ; we need a read/write buffer
        moveq   #err.rdo,d0
        tst.b   b_view(a4)
        bne     codend

        move.w  p.fld+2(a5),d2  ; field id
        bpl.s   notdef          ; no, we don't need the default
        move.b  b_dfield(a4),d2 ; default field
notdef  andi.w  #255,d2
        move.l  b_file(a4),a3   ; we need fileid

        ; now find out the field type
        moveq   #err.ipar,d0    ; assume fieldid doesn't exist
        move.l  d2,d1
        mulu    #18,d1          ; start of field
        add.w   #f_fields,d1    ; offset in filedata
        lea     0(a3,d1.w),a3   ; start of field
        tst.w   (a3)            ; does this field exist ?
        beq     codend          ; no it doesn't

        ; fieldtype ok ?
        cmpi.b  #ft.text,(a3)
        bne     codend

        ; check line to fill it in
        moveq   #err.orng,d0    ; assume not
        move.l  p.line(a5),d7   ; line to fill in
        ble     codend

        ; something will have changed
        move.b  #1,b_change(a4)

        ; now get the string
        ; and put start in a2 and length in d3
        moveq   #err.inam,d0    ; assume invalid name
        moveq   #0,d3           ; string length
        move.w  p.str-4(a5),d1  ; type of parameter
        beq.s   codcps          ; not specified -> empty string
        btst    #thp..str,d1    ; string parameter ?
        beq.s   codnstr         ; no -> ..
        move.l  p.str(a5),a2    ; ptr to name
        move.w  (a2)+,d3        ; string length
        bra.s   codcps          ; copy string
codnstr btst    #thp..sst,d1    ; sub-string parameter ?
        beq.s   codcps
        move.w  p.str-2(a5),d3  ; string length
        move.l  p.str(a5),a2    ; ptr to name
codcps

        ; so try to find this field
        move.l  b_mem(a4),a1    ; start of record
        move.l  b_rlen(a4),d1   ; recordlen
        xjsr    findfld         ; find it
        beq.s   old             ; overwrite old field -> ..

        ; ok, we have to create a new field for this one
        ; create the field
        move.l  d7,d1           ; line
        subq.l  #1,d1
        add.l   d3,d1           ; add line length to get field length
        xjsr    newfld          ; create it
        bne     codend          ; oops ...

        ; now clear the field
        move.l  p.line(a5),d1   ; loop counter
        lea     rf_fld(a1),a0   ; start of actual field
        subq.l  #2,d1           ; we don't have to clear all of them
        bmi     fillit
loop    move.b  #k.nl,(a0)+     ; add a new-line
        subq.l  #1,d1           ; another one ?
        bpl     loop
        bra     fillit

old     ; now overwrite the old field
        ; first see if the line already exists
        move.l  rf_len(a1),d1   ; length of field
        lea     rf_fld(a1),a0   ; actual start of field
        subq.l  #1,d7           ; one less nl to search
        beq.s   eflin           ; nothing to search
flin    subq.l  #1,d1           ; check another byte
        bmi.s   addlines        ; end reached -> add lines
        cmpi.b  #k.nl,(a0)+     ; reached the end of a line ?
        bne.s   flin
        subq.l  #1,d7           ; is this the line we need
        bgt.s   flin            ; no -> search next line
eflin
        ; a0 is now the start of the line we have to replace
        move.l  a0,a3           ; keep it in case we just have to overwrite
                                ; a0 will be preserved
        moveq   #-1,d2          ; length of line
flen    addq.l  #1,d2           ; line is one longer
        subq.l  #1,d1           ; check another byte
        bmi.s   gotlen          ; end reached -> this is the line end
        cmpi.b  #k.nl,(a3)+     ; reached the end of a line ?
        bne.s   flen
gotlen  ; the line length is now in d2, remaining nr of bytes in field in d1
        sub.l   d3,d2           ; get line length decrease
        beq.s   fillit          ; same -> just fill it in
        suba.l  a1,a0           ; get offset of start of line in field
        neg.l   d2              ; field len increase please
        bpl.s   longer          ; make it longer
        ; well we have to make it shorter
        tst.l   d1              ; do we have to copy some bytes ?
        bmi.s   decr
        ; we also heave to copy the newline
        move.b  -1(a3),-1(a3,d2.l)
loop3   move.b  (a3)+,-1(a3,d2.l)
        subq.l  #1,d1           ; make it all shorter
        bpl.s   loop3
decr    move.l  d2,d1           ; field increase (negative) in d1
        xjsr    incrfld         ; make field len correct
        bmi.s   codend          ; oops
        bra.s   fillin

longer  exg     d1,d2
        ; we have to make the field d1 longer
        ; therefore we have to copy d2 remaining bytes
        xjsr    incrfld         ; make field len correct
        bmi.s   codend          ; oops
        move.l  a1,a3
        move.l  rf_len(a3),d0   ; field len
        sub.l   d1,d0           ; offset of start of place to copy
        lea     rf_fld(a3,d0.l),a3      ; end of field
        tst.l   d2              ; do we have to copy some bytes ?
        bmi.s   fillin
loop4   move.b  -(a3),0(a3,d1.l)
        subq.l  #1,d2           ; make it all shorter
        bpl.s   loop4
        ; and fillin
fillin  ; used to fill the line after line increase or decrease
        adda.l  a1,a0           ; calculate start of line
        bra.s   fillit          ; and fill it in

addlines        ; we have to add some lines, and he actual field
        move.l  d7,d1           ; nr of newlines we have to add
        add.l   d3,d1           ; add linelength
        xjsr    incrfld         ; increase field length
        bne.s   codend          ; oops ...
        ; now clear the area we added
        move.l  rf_len(a1),d2
        sub.l   d1,d2
        sub.l   d3,d1           ; but we have to keep the space to put the actual line
        lea     rf_fld(a1,d2.l),a0      ; start of added area
loop2   move.b  #k.nl,(a0)+     ; add another new-line
        subq.l  #1,d1           ; another one ??
        bgt     loop2
        ; and fill in the line
fillit                          ; start of place to fill in string in a0
                                ; string still in a2, length in d3
cploop  move.b  (a2)+,(a0)+
        subq.l  #1,d3
        bgt     cploop
codend  subend
;
        end
