; routines which test and assure data integrity in DATAdesign
; most of the routines which need the data contained in the thing itself
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include win1_dd_src_engine_aid_mac
        include win1_dd_src_engine_struct_h
        include win1_inc_qdos_sms
        include win1_inc_keys_err
        xref    dde_name
; positions in INFO extension for the data and pointers
jobid    equ    $1a     ; id of 'DATAdesign files' job
filelist equ    $1e     ; head ptr of list of files
defbuff  equ    $22     ; start of array of default buffers
;
; get def buffer for this job (returned in d0)
getbuff xsub
        regsave d1-d3/a0-a4
        moveq   #sms.info,d0
        trap    #do.sms2        ; job id returned in d1

        xjsr    thg_fthg        ; find thing thing
        move.l  8(a3),a3        ; th_entry

        moveq   #sms.uthg,d0    ; use thing
        move.l  #'INFO',d2      ; extension name
        moveq   #-1,d3          ; timeout, forever
        lea     dde_name(pc),a0 ; thing name
        jsr     (a3)            ; do it, start of INFO extension in a1

        lsl.w   #2,d1           ; offset in array (d1 contains job id)
        move.l  defbuff(a1,d1.w),a4     ; default buffer for this job

        moveq   #sms.fthg,d0    ; free thing
        moveq   #sms.myjb,d1    ; job id
        lea     dde_name(pc),a0 ; thing name
        jsr     (a3)            ; do it

        move.l  a4,d0           ; result in d0
        subend

; set def buffer for this job (passed in d0)
setbuff xsub
        regsave d0-d3/d7/a0-a3
        move.l  d0,d7           ; just keep it for a while
        moveq   #sms.info,d0
        trap    #do.sms2        ; job id returned in d1

        xjsr    thg_fthg        ; find thing thing
        move.l  8(a3),a3        ; th_entry

        moveq   #sms.uthg,d0    ; use thing
        move.l  #'INFO',d2      ; extension name
        moveq   #-1,d3          ; timeout, forever
        lea     dde_name(pc),a0 ; thing name
        jsr     (a3)            ; do it, start of INFO extension in a1

        lsl.w   #2,d1           ; offset in array (d1 contains job id)
        move.l  d7,defbuff(a1,d1.w)     ; default buffer for this job

        moveq   #sms.fthg,d0    ; free thing
        moveq   #sms.myjb,d1    ; job id
        lea     dde_name(pc),a0 ; thing name
        jsr     (a3)            ; do it
        subend

; get id of first file in list
frstfid xsub
        regsave d1-d3/a0-a5
        xjsr    thg_fthg        ; fing thing thing
        move.l  8(a3),a3        ; th_entry

        moveq   #sms.uthg,d0    ; use thing
        moveq   #sms.myjb,d1    ; job id
        move.l  #'INFO',d2      ; extension name
        moveq   #-1,d3          ; timeout, forever
        lea     dde_name(pc),a0 ; thing name
        jsr     (a3)            ; do it, start of INFO extension in a1

        move.l  filelist(a1),a4 ; put first fid in a4 (return value)

        moveq   #sms.fthg,d0    ; free thing
        moveq   #sms.myjb,d1    ; job id
        lea     dde_name(pc),a0 ; thing name
        jsr     (a3)            ; do it

        move.l  a4,d0           ; return fid
        subend

; test if file id for valid DATAdesign file (passed in d0), result in d0
testfid xsub
        regsave d1-d3/a0-a5
        move.l  d0,d1
        moveq   #err.itnf,d0    ; assume faulty id
        btst    #0,d1           ; bit 0 cleared ?
        bne.s   fidend          ; no -> forget it
        tst.l   d1              ; zero
        beq.s   fidend          ; yes -> forget it
        move.l  d1,a5           ; put in in a good, safe place

        ; check the flag
        cmpi.l  #'DATA',f_flag(a5)
        bne.s   fidend
        cmpi.l  #'desi',f_flag+4(a5)
        bne.s   fidend
        cmpi.l  #'gn f',f_flag+8(a5)
        bne.s   fidend
        cmpi.l  #'ile ',f_flag+12(a5)
        bne.s   fidend

        xjsr    thg_fthg        ; fing thing thing
        move.l  8(a3),a3        ; th_entry

        moveq   #sms.uthg,d0    ; use thing
        moveq   #sms.myjb,d1    ; job id
        move.l  #'INFO',d2      ; extension name
        moveq   #-1,d3          ; timeout, forever
        lea     dde_name(pc),a0 ; thing name
        jsr     (a3)            ; do it, start of INFO extension in a1

        move.l  a1,a4           ; put start of INFO thing in a good safe place

        moveq   #sms.fthg,d0    ; free thing
        moveq   #sms.myjb,d1    ; job id
        lea     dde_name(pc),a0 ; thing name
        jsr     (a3)            ; do it

        ; now we wil try to find the file pointer in the list
        lea     filelist(a4),a4 ; start of list of pointers
        moveq   #err.itnf,d0    ; assume not found
fidnxt  move.l  (a4),d1         ; get it
        beq.s   fidend          ; end of list -> not found
        move.l  d1,a4           ; new start of list
        cmpa.l  a4,a5           ; is this the one we are searching
        bne.s   fidnxt          ; no -> start again
        moveq   #0,d0           ; we found it -> no error
fidend
        subend

; test if buffer id for valid DATAdesign buffer (passed in d0), result in d0
testbid xsub
        regsave d1-d3/a0-a5
        move.l  d0,d1
        moveq   #err.itnf,d0    ; assume faulty id
        btst    #0,d1           ; bit 0 cleared ?
        bne.s   bidend          ; no -> forget it
        tst.l   d1              ; zero ??
        beq.s   bidend          ; yes -> forget it
        move.l  d1,a5           ; put in in a good, safe place

        ; check the flag
        cmpi.l  #'DATA',b_flag(a5)
        bne.s   bidend
        cmpi.l  #'desi',b_flag+4(a5)
        bne.s   bidend
        cmpi.l  #'gn b',b_flag+8(a5)
        bne.s   bidend
        cmpi.l  #'uffr',b_flag+12(a5)
        bne.s   bidend

        ; and the jobid
        moveq   #sms.info,d0
        trap    #do.sms2        ; job id returned in d1
        moveq   #err.itnf,d0    ; assume faulty
        cmp.l   b_jobid(a5),d1  ; vgl
        bne.s   bidend

        move.l  b_file(a5),d0   ; get id of file which owns this buffer
        bsr     testfid         ; check if it is valid
        bne.s   bidend          ; problem -> not valid

        ; now we wil try to find the buffer pointer in the list
        move.l  b_file(a5),a4   ; file id
        lea     f_buffer(a4),a4 ; start of list of pointers to buffers
        moveq   #err.itnf,d0    ; assume not found
bidnxt  move.l  (a4),d1         ; get it
        beq.s   bidend          ; end of list -> not found
        move.l  d1,a4           ; new start of list
        cmpa.l  a4,a5           ; is this the one we are searching
        bne.s   bidnxt          ; no -> start again
        moveq   #0,d0           ; we found it -> no error
bidend
        subend

; test if index id for valid DATAdesign index (passed in d0), result in d0
testiid xsub
        regsave d1-d3/a0-a5
        move.l  d0,d1
        moveq   #err.itnf,d0    ; assume faulty id
        btst    #0,d1           ; bit 0 cleared ?
        bne.s   iidend          ; no -> forget it
        tst.l   d1              ; zero ?
        beq.s   iidend          ; yes -> forget it
        move.l  d1,a5           ; put in in a good, safe place

        ; check the flag
        cmpi.l  #'DATA',i_flag(a5)
        bne.s   iidend
        cmpi.l  #'desi',i_flag+4(a5)
        bne.s   iidend
        cmpi.l  #'gn i',i_flag+8(a5)
        bne.s   iidend
        cmpi.l  #'ndex',i_flag+12(a5)
        bne.s   iidend

        move.l  i_buffer(a5),d0 ; get id of file which owns this buffer
        bsr     testbid         ; check if it is valid
        bne.s   iidend          ; problem -> not valid

        ; now we wil try to find the index pointer in the list
        move.l  i_buffer(a5),a4 ; file id
        lea     b_index(a4),a4  ; start of list of pointers to buffers
        moveq   #err.itnf,d0    ; assume not found
iidnxt  move.l  (a4),d1         ; get it
        beq.s   iidend          ; end of list -> not found
        move.l  d1,a4           ; new start of list
        cmpa.l  a4,a5           ; is this the one we are searching
        bne.s   iidnxt          ; no -> start again
        moveq   #0,d0           ; we found it -> no error
iidend
        subend

; unlink file from list of DATAdesign files (passed in d0)
; only works if file not used by a buffer (or d0=err.fdiu)
unlnkfid xsub
        regsave d1-d3/d7/a0-a3
        move.l  d0,d7           ; just keep it for a while

        xjsr    thg_fthg        ; find thing thing
        move.l  8(a3),a3        ; th_entry

        moveq   #sms.uthg,d0    ; use thing
        moveq   #sms.myjb,d1    ; job id
        move.l  #'INFO',d2      ; extension name
        moveq   #-1,d3          ; timeout, forever
        lea     dde_name(pc),a0 ; thing name
        jsr     (a3)            ; do it, start of INFO extension in a1

        mutex                   ; for all safety reasons
        move.l  d7,a0
        moveq   #err.fdiu,d0    ; assume in use
        tst.l   f_buffer(a0)    ; can file be freed ?
        bne.s   inus

        lea     filelist(a1),a1 ; place of link
        move.l  d7,a2           ; adrress to unlink
        bsr.s   unlink          ; unlink it
        moveq   #0,d0           ; clear error
inus    endmutex                ; back to user mode

        move.l  d0,d7           ; preserve error
        moveq   #sms.fthg,d0    ; free thing
        moveq   #sms.myjb,d1    ; job id
        lea     dde_name(pc),a0 ; thing name
        jsr     (a3)            ; do it
        move.l  d7,d0           ; restore error
        subend

; unlink an item (a2) from a single linked list (a1), link always first long word
; a1 can be corrupted
unlink  xsub
        tst.l   (a1)            ; just check if there is a list of files
        beq.s   nounlk          ; no -> it is unlinked already
        cmpa.l  (a1),a2         ; do we have to unlink the next one ?
        beq.s   unlk            ; yep, do it
        move.l  (a1),a1         ; take next one
        bra.s   unlink          ; and unlink the item
unlk
        move.l  (a2),(a1)       ; unlink the item
nounlk
        subend

; link file in list of DATAdesign files (passed in d0)
linkfid xsub
        regsave d1-d3/d7/a0-a3
        move.l  d0,d7           ; just keep it for a while

        xjsr    thg_fthg        ; find thing thing
        move.l  8(a3),a3        ; th_entry

        moveq   #sms.uthg,d0    ; use thing
        moveq   #sms.myjb,d1    ; job id
        move.l  #'INFO',d2      ; extension name
        moveq   #-1,d3          ; timeout, forever
        lea     dde_name(pc),a0 ; thing name
        jsr     (a3)            ; do it, start of INFO extension in a1

        move.l  d7,a2           ; item to link in
        linkin  filelist(a1),a2

        moveq   #sms.fthg,d0    ; free thing
        moveq   #sms.myjb,d1    ; job id
        lea     dde_name(pc),a0 ; thing name
        jsr     (a3)            ; do it
        subend

; reserve some memory for the 'DATAdesign files' job, and clear it
; nr of bytes in d1, start address in a0, length in d1
getmem  xsub
        regsave d2-d4/d7/a1-a3
        move.l  d1,d7           ; just keep it for a while

        xjsr    thg_fthg        ; find thing thing
        move.l  8(a3),a3        ; th_entry

        moveq   #sms.uthg,d0    ; use thing
        moveq   #sms.myjb,d1    ; job id
        move.l  #'INFO',d2      ; extension name
        moveq   #-1,d3          ; timeout, forever
        lea     dde_name(pc),a0 ; thing name
        jsr     (a3)            ; do it, start of INFO extension in a1

        move.l  jobid(a1),d4    ; just set the job id aside for a while

        moveq   #sms.fthg,d0    ; free thing
        moveq   #sms.myjb,d1    ; job id
        lea     dde_name(pc),a0 ; thing name
        jsr     (a3)            ; do it

        moveq   #sms.achp,d0    ; allocate some memory
        move.l  d4,d2           ; job id
        move.l  d7,d1           ; nr of bytes requred
        trap    #do.sms2
        sub.l   #$10,d1         ; subtract room for header (make available space correct)
        tst.l   d0
        bne.s   achpend

        ; now we will clear this memory
        move.l  a0,a1           ; start of area to clear
        move.l  d1,d2           ; nr of bytes to clear
        lsr.l   #2,d2           ; nr of long words to clear
        subq.l  #1,d2           ; adjust to dbf
achpclr clr.l   (a1)+
        dbf     d2,achpclr
achpend
        subend

; release some memory, okay, it shouldn't be here, but it fits with getmem
; a0 base of area to free
relmem  xsub
        regsave d1-d3/a1-a3
        moveq   #sms.rchp,d0    ; release it again
        trap    #do.sms2
        subend

; get id of job owning the memory
getjid xsub
        regsave d1-d3/a0-a4
        xjsr    thg_fthg        ; find thing thing
        move.l  8(a3),a3        ; th_entry

        moveq   #sms.uthg,d0    ; use thing
        moveq   #sms.myjb,d1    ; job id
        move.l  #'INFO',d2      ; extension name
        moveq   #-1,d3          ; timeout, forever
        lea     dde_name(pc),a0 ; thing name
        jsr     (a3)            ; do it, start of INFO extension in a1

        move.l  jobid(a1),a4

        moveq   #sms.fthg,d0    ; free thing
        moveq   #sms.myjb,d1    ; job id
        lea     dde_name(pc),a0 ; thing name
        jsr     (a3)            ; do it

        move.l  a4,d0           ; result in d0
        subend

; reserve some memory for the 'DATAdesign files' job
; nr of bytes in d1, start address in a0, length in d1
; special version that can be called from supervisor
getsmem xsub
        regsave d2/d3/a1-a3
        bsr     getjid          ; get 'DATAdesign files' job id
        move.l  d0,d2           ; and put in d2
        moveq   #sms.achp,d0    ; allocate some memory
        trap    #do.sms2
        sub.l   #$10,d1         ; subtract room for header (make available space correct)
        tst.l   d0              ; error ?
        bmi.s   achend

        ; now we will clear this memory
        move.l  a0,a1           ; start of area to clear
        move.l  d1,d2           ; nr of bytes to clear
        lsr.l   #2,d2           ; nr of long words to clear
        subq.l  #1,d2           ; adjust to dbf
achclr  clr.l   (a1)+
        dbf     d2,achclr
achend  subend

; get the first fid in list (returned in d0)
getflist xsub
        regsave d1-d3/a0-a4
        moveq   #sms.info,d0
        trap    #do.sms2        ; job id returned in d1

        xjsr    thg_fthg        ; find thing thing
        move.l  8(a3),a3        ; th_entry

        moveq   #sms.uthg,d0    ; use thing
        moveq   #sms.myjb,d1    ; job id
        move.l  #'INFO',d2      ; extension name
        moveq   #-1,d3          ; timeout, forever
        lea     dde_name(pc),a0 ; thing name
        jsr     (a3)            ; do it, start of INFO extension in a1

        move.l  filelist(a1),a4 ; address of list of files

        moveq   #sms.fthg,d0    ; free thing
        moveq   #sms.myjb,d1    ; job id
        lea     dde_name(pc),a0 ; thing name
        jsr     (a3)            ; do it

        move.l  a4,d0           ; result in d0
        subend

; get the cureent date, returned in d0
getdate xsub
        regsave d1/d2/a0
        moveq   #sms.rrtc,d0    ; Read Real Time Clock
        trap    #do.sms2
        move.l  d1,d0           ; and return value in d0
        subend
;
        end
